DCMTK: DcmTagKey Class Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Private Attributes | Friends | List of all members
DcmTagKey Class Reference

class maintaining a attribute tag (group and element number) More...

Inheritance diagram for DcmTagKey:

## Public Member Functions
| DcmTagKey ()
| default constructor
| DcmTagKey (const DcmTagKey &key)
| copy constructor
| DcmTagKey (Uint16 g, Uint16 e)
| constructor
virtual | ~DcmTagKey ()
| destructor
void | set (const DcmTagKey &key)
| set value to given tag key
void | set (Uint16 g, Uint16 e)
| set value to given group and element
void | setGroup (Uint16 g)
| set group to given number
void | setElement (Uint16 e)
| set element to given number
Uint16 | getGroup () const
| returns group number
Uint16 | getElement () const
| returns element number
DcmTagKey | getBaseTag () const
| returns base tag, i.e.
OFBool | isGroupLength () const
| checks whether the tag key is a valid group length element.
OFBool | isPrivate () const
| returns true if the tag key is private, i.e.
OFBool | isPrivateReservation () const
| returns true, if tag is a private reservation tag of the form (gggg,00xx) with "gggg" being odd and "xx" in the range of 10 and FF.
OFBool | hasValidGroup () const
| returns true, if group is valid (permitted in DICOM command or data sets).
Uint32 | hash () const
| generate a simple hash code for this attribute tag.
DcmTagKey & | operator= (const DcmTagKey &key)
| assignment operator for initializing this tag key from an existing one
OFBool | operator== (const DcmTagKey &key) const
| comparison operator.
OFBool | operator!= (const DcmTagKey &key) const
| negation operator.
OFBool | operator< (const DcmTagKey &key) const
| 'less than' operator.
OFBool | operator> (const DcmTagKey &key) const
| 'greater than' operator.
OFBool | operator<= (const DcmTagKey &key) const
| 'less or equal' operator.
OFBool | operator>= (const DcmTagKey &key) const
| 'greater or equal' operator.
OFString | toString () const
| convert tag key to string having the form "(gggg,eeee)".
OFBool | isSignableTag () const
| returns true if a data element with the given tag key can be digitally signed, false otherwise

## Protected Member Functions
int | groupLT (const DcmTagKey &key) const
| less-than operation comparing only group numbers
int | groupGT (const DcmTagKey &key) const
| greater-than operation comparing only group numbers
int | groupEQ (const DcmTagKey &key) const
| comparison operation comparing only group numbers
int | elementLT (const DcmTagKey &key) const
| less-than operation comparing only element numbers
int | elementGT (const DcmTagKey &key) const
| greater-than operation comparing only element numbers
int | elementEQ (const DcmTagKey &key) const
| comparison operation comparing only element numbers

## Private Attributes
Uint16 | group
| tag group number
Uint16 | element
| tag element number

## Friends
DCMTK_DCMDATA_EXPORT STD_NAMESPACE ostream & | operator<< (STD_NAMESPACE ostream &s, const DcmTagKey &k)
| stream output operator for tag keys

## Detailed Description

class maintaining a attribute tag (group and element number)

## Constructor & Destructor Documentation

## ◆ DcmTagKey() [1/2]

DcmTagKey::DcmTagKey | ( | const DcmTagKey & | key | ) |
| inline

copy constructor

Parameters

  key | [in] The tag key to initialize from

References DcmTagKey(), element, and group.

## ◆ DcmTagKey() [2/2]

DcmTagKey::DcmTagKey | ( | Uint16 | g,
|  | Uint16 | e )
| inline

constructor

Parameters

  g | group
  e | element

References element, and group.

## Member Function Documentation

## ◆ elementEQ()

int DcmTagKey::elementEQ | ( | const DcmTagKey & | key | ) | const
| inlineprotected

comparison operation comparing only element numbers

Parameters

  key | the object to compare to

References DcmTagKey(), and getElement().

Referenced by isSignableTag(), and operator==().

## ◆ elementGT()

int DcmTagKey::elementGT | ( | const DcmTagKey & | key | ) | const
| inlineprotected

greater-than operation comparing only element numbers

Parameters

  key | the object to compare to

References DcmTagKey(), and getElement().

Referenced by isSignableTag(), and operator>().

## ◆ elementLT()

int DcmTagKey::elementLT | ( | const DcmTagKey & | key | ) | const
| inlineprotected

less-than operation comparing only element numbers

Parameters

  key | the object to compare to

References DcmTagKey(), and getElement().

Referenced by isSignableTag(), and operator<().

## ◆ getBaseTag()

DcmTagKey DcmTagKey::getBaseTag | ( |  | ) | const

returns base tag, i.e.

in case of a repeating group tag always the base group number 0x5000 (curve) or 0x6000 (overlay) is used. For non-repeating group tags "this" tag key is returned.

Returns
  returns the base tag of the tag key

References DcmTagKey(), hash(), hasValidGroup(), isGroupLength(), isPrivate(), and isPrivateReservation().

## ◆ getElement()

Uint16 DcmTagKey::getElement | ( |  | ) | const
| inline

returns element number

Returns
  returns the element number of the tag key

References element.

Referenced by DcmDictEntry::contains(), elementEQ(), elementGT(), elementLT(), DcmTag::getETag(), hash(), DcmDictEntry::isRepeatingElement(), DcmDictEntry::setEQ(), and DcmDictEntry::subset().

## ◆ getGroup()

Uint16 DcmTagKey::getGroup | ( |  | ) | const
| inline

returns group number

Returns
  returns the group number of the tag key

References group.

Referenced by DcmDictEntry::contains(), DcmTag::getGTag(), groupEQ(), groupGT(), groupLT(), hash(), DcmDictEntry::isRepeatingGroup(), DcmDictEntry::setEQ(), and DcmDictEntry::subset().

## ◆ groupEQ()

int DcmTagKey::groupEQ | ( | const DcmTagKey & | key | ) | const
| inlineprotected

comparison operation comparing only group numbers

Parameters

  key | the object to compare to

References DcmTagKey(), and getGroup().

Referenced by isSignableTag(), operator<(), operator==(), and operator>().

## ◆ groupGT()

int DcmTagKey::groupGT | ( | const DcmTagKey & | key | ) | const
| inlineprotected

greater-than operation comparing only group numbers

Parameters

  key | the object to compare to

References DcmTagKey(), and getGroup().

Referenced by isSignableTag(), and operator>().

## ◆ groupLT()

int DcmTagKey::groupLT | ( | const DcmTagKey & | key | ) | const
| inlineprotected

less-than operation comparing only group numbers

Parameters

  key | the object to compare to

References DcmTagKey(), and getGroup().

Referenced by isSignableTag(), and operator<().

## ◆ hash()

Uint32 DcmTagKey::hash | ( |  | ) | const
| inline

generate a simple hash code for this attribute tag.

Used for fast look-up in the DICOM dictionary.

Returns
  hash code for this tag

References getElement(), and getGroup().

Referenced by getBaseTag().

## ◆ hasValidGroup()

OFBool DcmTagKey::hasValidGroup | ( |  | ) | const
| inline

returns true, if group is valid (permitted in DICOM command or data sets).

Referring to the standard, groups 1, 3, 5, 7 and 0xFFFF are illegal.

Returns
  returns OFTrue if tag key has a valid group number.

References group.

Referenced by getBaseTag(), isGroupLength(), and isPrivate().

## ◆ isGroupLength()

OFBool DcmTagKey::isGroupLength | ( |  | ) | const
| inline

checks whether the tag key is a valid group length element.

Also calls hasValidGroup().

Returns
  returns OFTrue if tag key is a valid group length element

References element, and hasValidGroup().

Referenced by getBaseTag().

## ◆ isPrivate()

OFBool DcmTagKey::isPrivate | ( |  | ) | const
| inline

returns true if the tag key is private, i.e.

whether it has an odd group number. Also hasValidGroup() is called.

Returns
  returns OFTrue if group is private and valid.

References group, and hasValidGroup().

Referenced by getBaseTag(), and isPrivateReservation().

## ◆ isPrivateReservation()

OFBool DcmTagKey::isPrivateReservation | ( |  | ) | const
| inline

returns true, if tag is a private reservation tag of the form (gggg,00xx) with "gggg" being odd and "xx" in the range of 10 and FF.

Returns
  returns OFTrue if tag key is a private reservation key

References element, and isPrivate().

Referenced by getBaseTag().

## ◆ isSignableTag()

OFBool DcmTagKey::isSignableTag | ( |  | ) | const

returns true if a data element with the given tag key can be digitally signed, false otherwise

Returns
  true if signable, false otherwise

References DcmTagKey(), elementEQ(), elementGT(), elementLT(), groupEQ(), groupGT(), and groupLT().

## ◆ operator!=()

OFBool DcmTagKey::operator!= | ( | const DcmTagKey & | key | ) | const
| inline

negation operator.

Returns true if either group or element number are not the same.

Parameters

  key | key to compare with

Returns
  true if tag keys are not the same

References DcmTagKey().

## ◆ operator<()

OFBool DcmTagKey::operator< | ( | const DcmTagKey & | key | ) | const
| inline

'less than' operator.

Returns true if the given tag key is greater than "this".

Parameters

  key | key to compare with

Returns
  true if given key is greater than "this"

References DcmTagKey(), elementLT(), groupEQ(), and groupLT().

## ◆ operator<=()

OFBool DcmTagKey::operator<= | ( | const DcmTagKey & | key | ) | const
| inline

'less or equal' operator.

Returns true if the given tag key is greater or the same as "this".

Parameters

  key | key to compare with

Returns
  true if given key is greater or the same as "this"

References DcmTagKey().

## ◆ operator=()

DcmTagKey & DcmTagKey::operator= | ( | const DcmTagKey & | key | ) |
| inline

assignment operator for initializing this tag key from an existing one

Parameters

  key | [in] The key to copy from

Returns
  "this" initialization

References DcmTagKey(), and set().

## ◆ operator==()

OFBool DcmTagKey::operator== | ( | const DcmTagKey & | key | ) | const
| inline

comparison operator.

Returns true if both group and element number are the same.

Parameters

  key | key to compare with

Returns
  true if tag keys are the same

References DcmTagKey(), elementEQ(), and groupEQ().

## ◆ operator>()

OFBool DcmTagKey::operator> | ( | const DcmTagKey & | key | ) | const
| inline

'greater than' operator.

Returns true if the given tag key is smaller than "this".

Parameters

  key | key to compare with

Returns
  true if "this" key is smaller than given one.

References DcmTagKey(), elementGT(), groupEQ(), and groupGT().

## ◆ operator>=()

OFBool DcmTagKey::operator>= | ( | const DcmTagKey & | key | ) | const
| inline

'greater or equal' operator.

Returns true if the given tag key is smaller or equal as "this".

Parameters

  key | key to compare with

Returns
  true if "this" key is smaller or equal to given one.

References DcmTagKey().

## ◆ set() [1/2]

void DcmTagKey::set | ( | const DcmTagKey & | key | ) |
| inline

set value to given tag key

Parameters

  key | attribute tag to copy

References DcmTagKey(), element, and group.

Referenced by operator=().

## ◆ set() [2/2]

void DcmTagKey::set | ( | Uint16 | g,
|  | Uint16 | e )
| inline

set value to given group and element

Parameters

  g | group
  e | element

References element, and group.

## ◆ setElement()

void DcmTagKey::setElement | ( | Uint16 | e | ) |
| inline

set element to given number

Parameters

  e | element

References element.

## ◆ setGroup()

void DcmTagKey::setGroup | ( | Uint16 | g | ) |
| inline

set group to given number

Parameters

  g | group

References group.

## ◆ toString()

OFString DcmTagKey::toString | ( |  | ) | const

convert tag key to string having the form "(gggg,eeee)".

Returns
  the string representation of this tag key

## Related Definitions

## ◆ operator<<

DCMTK_DCMDATA_EXPORT STD_NAMESPACE ostream & operator<< | ( | STD_NAMESPACE ostream & | s,
|  | const DcmTagKey & | k )
| friend

stream output operator for tag keys

Parameters

  s | output stream
  k | tag key

Returns
  reference to output stream

References DcmTagKey().

The documentation for this class was generated from the following file:

- dcmdata/include/dcmtk/dcmdata/dctagkey.h

Generated on Sat Mar 1 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2